# junos_static_route – Manage static IP routes on Juniper JUNOS network devices

New in version 2.4.

- Synopsis

- Requirements

- Parameters

- Notes

- Examples

- Return Values

- Status

## Synopsis

- This module provides declarative management of static IP routes on Juniper JUNOS network devices.

## Requirements

The below requirements are needed on the host that executes this module.

- ncclient (>=v0.5.2)

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---

active
boolean

Choices:
- no
- yes ←

Specifies whether or not the configuration is active or deactivated

address - / required |  | Network address with prefix of the static route. aliases: prefix
aggregate - |  | List of static route definitions
next_hop - / required |  | Next hop IP of the static route.
preference - |  | Global admin preference of the static route. aliases: admin_distance

provider
dictionary

Deprecated
Starting with Ansible 2.5 we recommend using `connection: network_cli` or `connection: netconf`.
For more information please see the Junos OS Platform Options guide.

A dict object containing connection details.

| host string / required |  | Specifies the DNS host name or address for connecting to the remote device over the specified transport. The value of host is used as the destination address for the transport.
| password string |  | Specifies the password to use to authenticate the connection to the remote device. This value is used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_PASSWORD` will be used instead.
| port integer | Default: 22 | Specifies the port to use when building the connection to the remote device. The port value will default to the well known SSH port of 22 (for `transport=cli`) or port 830 (for `transport=netconf`) device.
| ssh_keyfile path |  | Specifies the SSH key to use to authenticate the connection to the remote device. This value is the path to the key used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_SSH_KEYFILE` will be used instead.
| timeout integer | Default: 10 | Specifies the timeout in seconds for communicating with the network device for either connecting or sending commands. If the timeout is exceeded before the operation is completed, the module will error.
| username string |  | Configures the username to use to authenticate the connection to the remote device. This value is used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_USERNAME` will be used instead.
qualified_next_hop - |  | Qualified next hop IP of the static route. Qualified next hops allow to associate preference with a particular next-hop address.
qualified_preference - |  | Assign preference for qualified next hop.

state
-

Choices:
- present ←
- absent

State of the static route configuration.

## Notes

Note

- This module requires the netconf system service be enabled on the remote device being managed.

- Tested against vSRX JUNOS version 15.1X49-D15.4, vqfx-10000 JUNOS Version 15.1X53-D60.4.

- Recommended connection is `netconf`. See the Junos OS Platform Options.

- This module also works with `local` connections for legacy playbooks.

- For information on using CLI and netconf see the Junos OS Platform Options guide

- For more information on using Ansible to manage network devices see the Ansible Network Guide

- For more information on using Ansible to manage Juniper network devices see https://www.ansible.com/ansible-juniper.

## Examples

    - name: configure static route
      junos_static_route:
        address: 192.168.2.0/24
        next_hop: 10.0.0.1
        preference: 10
        qualified_next_hop: 10.0.0.2
        qualified_preference: 3
        state: present

    - name: delete static route
      junos_static_route:
        address: 192.168.2.0/24
        state: absent

    - name: deactivate static route configuration
      junos_static_route:
        address: 192.168.2.0/24
        next_hop: 10.0.0.1
        preference: 10
        qualified_next_hop: 10.0.0.2
        qualified_preference: 3
        state: present
        active: False

    - name: activate static route configuration
      junos_static_route:
        address: 192.168.2.0/24
        next_hop: 10.0.0.1
        preference: 10
        qualified_next_hop: 10.0.0.2
        qualified_preference: 3
        state: present
        active: True

    - name: Configure static route using aggregate
      junos_static_route:
        aggregate:
        - { address: 4.4.4.0/24, next_hop: 3.3.3.3, qualified_next_hop: 5.5.5.5, qualified_preference: 30 }
        - { address: 5.5.5.0/24, next_hop: 6.6.6.6, qualified_next_hop: 7.7.7.7, qualified_preference: 12 }
        preference: 10

    - name: Delete static route using aggregate
      junos_static_route:
        aggregate:
        - address: 4.4.4.0/24
        - address: 5.5.5.0/24
        state: absent

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
diff.prepared string | when configuration is changed and diff option is enabled. | Configuration difference before and after applying change. Sample: [edit routing-options static] route 2.2.2.0/24 { ... } + route 4.4.4.0/24 { next-hop 3.3.3.3; qualified-next-hop 5.5.5.5 { + preference 30; } + preference 10; + }

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]

- This module is maintained by the Ansible Network Team. [network]

### Red Hat Support

More information about Red Hat’s support of this module is available from this Red Hat Knowledge Base article.

### Authors

- Ganesh Nalawade (@ganeshrn)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.